# -*- coding: utf-8 -*-
'''
Created on 2010/10/08
 SHsSL XML output class.
@author: toru kageyama <info@comona.co.jp>
'''
#imports.
from binascii import b2a_base64

# XML output class.
class XmlFormatter(object):
    """XML output class."""

    # constructor.
    def __init__(self):
        """constructor."""
        self.login_result = False
        self.command_result = False
        self.command_name = ''
        self.current_directory = ''
        self.result_data = []

    # login result.
    def set_login_result(self, login_result):
        """login result."""
        self.login_result = login_result

    # command name.
    def set_command_name(self, command_name):
        """command name."""
        self.command_name = command_name

    # command result.
    def set_command_result(self, command_result):
        """command result."""
        self.command_result = command_result

    # set current directory.
    def set_current_directory(self, current_directory):
        """set current directory."""
        self.current_directory = current_directory

    # get current directory.
    def get_current_directory(self):
        """get current directory."""
        return self.current_directory

    # append result data.
    def append_result_data(self, result_data):
        """append result data."""
        self.result_data.append(result_data)

    # RETR command call back function.
    def retr_callback(self, block):
        """RETR command call back function."""
        self.append_result_data(RetrContent(block)) # append RetrContent class.

    # print out XML.
    def print_out(self):
        """print out."""
        # print header.
        print "Content-type:text/xml; charset='UTF-8'\r\n";
        print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
        print "<shssl type=\"ft\">"
        self.print_login_result()
        self.print_command_and_result()
        print '<current_dir>' + self.current_directory + '</current_dir>'   # current directory.

        print '<result_count>' + str(len(self.result_data)) + '</result_count>'
        # result of each command.
        for cmd_result in self.result_data:
            cmd_result.print_out()

        print "</shssl>"    # XML done.

    # print login result.
    def print_login_result(self):
        """print login result."""
        if self.login_result == False:
            result_str = 'FALSE'
        else:
            result_str = 'TRUE'
        print '<login_result>' + result_str + '</login_result>'

    # print login result.
    def print_command_and_result(self):
        """print login result."""
        # command name.
        print '<command>' + self.command_name + '</command>'
        # command result.
        if self.command_result == False:
            result_str = 'FALSE'
        else:
            result_str = 'TRUE'
        print '<command_result>' + result_str + '</command_result>'

# RETR content class.
class RetrContent(object):
    """RETR content class."""

    # constructor.
    def __init__(self, content):
        """constructor."""
        self.content = content

    # print out.
    def print_out(self):
        """print out."""
        print '<retr>' + b2a_base64(self.content) + '</retr>'   # base64
 